const changeAvatar = (avatar) => {
  $('#avatar').attr('src', `/media/avatars/${avatar}`);
};

const attributes = {
  'strength': 10,
  'constitution': 10,
  'dexterity': 10,
  'intelligence': 10,
  'wisdom': 10,
  'charisma': 10
};

const costTable = {
  7: -4,
  8: -2,
  9: -1,
  10: 0,
  11: 1,
  12: 2,
  13: 3,
  14: 5,
  15: 7,
  16: 10,
  17: 13,
  18: 17
};

const getScore = () => Object.keys(attributes).reduce((total, el) => total + costTable[attributes[el]], 0);

const characters = {};

const updateActionPoints = (characterId, characterActionPoints, maxActionPoints) => {
  const timer = setInterval(() => {
    if (characters[characterId].characterActionPoints >= maxActionPoints) {
      clearInterval(characters[characterId].timer);
    } else {
      $('#action-points-bar-'+characterId).progress('increment', 1);
      characters[characterId].characterActionPoints ++;
      document.getElementById('action-points-value-'+characterId).innerHTML = characters[characterId].characterActionPoints;
    }
  }, 1000*60*3);
  characters[characterId] = { timer, characterActionPoints };
};

const reduceAttribute = (attribute, initAttributesPoints) => {
  attributes[attribute] --;
  if (attributes[attribute]<7) {
    attributes[attribute] ++;
    alert("You can't have attribute under 7.");
  } else {
    document.getElementById(attribute).innerText = attributes[attribute];
    $(`#${attribute}-bar`).progress('decrement', 1);
    document.getElementById('available-points').innerHTML = initAttributesPoints - getScore();
  }
};

const augmentAttribute = (attribute, initAttributesPoints) => {
  attributes[attribute] ++;
  if (getScore()>initAttributesPoints) {
    attributes[attribute] --;
    alert("Not enough points.");
  } else if (attributes[attribute]>18) {
    alert("You can't have attribute over 18.");
    attributes[attribute] --;
  } else {
    document.getElementById(attribute).innerText = attributes[attribute];
    $(`#${attribute}-bar`).progress('increment', 1);
    document.getElementById('available-points').innerHTML = initAttributesPoints - getScore();
  }
};

const createCharacter = () => {
  const form = document.getElementById('create-character');
  Object.keys(attributes).forEach(attribute => {
    const input = document.createElement("input");
    input.setAttribute("name", attribute);
    input.setAttribute("value", attributes[attribute]);
    input.setAttribute("type", "hidden");
    form.appendChild(input);
  });
  form.submit();
};
