const mongoose = require('mongoose');
const random = require('random');
const fs = require('fs');
const { maxActionPoints } = require('js-yaml').safeLoad(fs.readFileSync('./config.yml', 'utf8'));

const Character = new mongoose.Schema({
  user: { type: mongoose.Schema.Types.ObjectId, ref: 'User', required: true },
  name: { type: String, require: true },
  avatar: { type: String },
  birthDate: { type: Date, required: true, default: Date.now },
  actionPoints: { type: Number, default: maxActionPoints, min: 0, max: maxActionPoints },
  attributes: {
    strength: { type: Number, default: 10 },
    constitution: { type: Number, default: 10 },
    dexterity: { type: Number, default: 10 },
    intelligence: { type: Number, default: 10 },
    wisdom: { type: Number, default: 10 },
    charisma: { type: Number, default: 10 },
  }
});

function randomAttribute() {
  let dices = [];
  let min = random.int(1,6);
  for (let i = 0; i < 3; i++) {
    let number = random.int(1,6);
    if (number < min) {
      dices.push(min);
      min = number;
    } else {
      dices.push(number);
    }
  }
  return dices.reduce((total, val) => total + val);
}

// Character.statics.generateCharacter = async function(name, userId, avatar) {
//   const character = await this.create({
//     name,
//     user: userId,
//     avatar,
//     attributes: {
//       strength: randomAttribute(),
//       constitution: randomAttribute(),
//       dexterity: randomAttribute(),
//       intelligence: randomAttribute(),
//       wisdom: randomAttribute(),
//       charisma: randomAttribute(),
//     }
//   });
//   return character;
// }

module.exports = mongoose.model('Character', Character);