const cron = require('node-cron');
const fs = require('fs');
const Character = require('../models/character');
const { maxActionPoints } = require('js-yaml').safeLoad(fs.readFileSync('./config.yml', 'utf8'));

if (!fs.existsSync('./data/lastActionPointsUpdate')) {
  fs.writeFileSync('./data/lastActionPointsUpdate', new Date().toString());
  console.log("Missing data file, generating...");
}

cron.schedule('*/3 * * * *', () => {
  // Read last time
  let lastUpdate = new Date(fs.readFileSync('./data/lastActionPointsUpdate').toString());
  // Loop until now
  while (lastUpdate.getTime() < new Date().getTime() - 3*1000) {
    // Give a point
    Character.where('actionPoints').lt(maxActionPoints)
      .exec((err, characters) => {
        characters.forEach(character => {
          character.actionPoints ++;
          character.save();
        });
      });
    // Write lastime
    lastUpdate = new Date(fs.readFileSync('./data/lastActionPointsUpdate').toString());
    lastUpdate = new Date(lastUpdate.getTime() + 3*1000);
    fs.writeFileSync('./data/lastActionPointsUpdate', lastUpdate.toString());
  }
});
