const render = (req, res, view, options) => {
  // Load notifications
  if (req.session.user) {
      res.render(view, {
        ...options,
        user: req.session.user,
        nextUrl: req.url,
        notifications: req.session.user.notifications
      });
      req.session.user.notifications
        .filter(notification => !notification.persistant)
        .forEach(notification => notification.remove());
      req.session.user.save();
  } else {
    return res.render(view, {
      ...options,
      user: req.session.user,
      nextUrl: req.url,
      notifications: []
    });
  }
};

module.exports = render;